



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++很“虚”</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++很“虚”</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 20:10:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>0引言：在学习C++时，碰到过以下四个以&ldquo;虚&rdquo;命名的概念，在系统理解这些高大上的术语后，才发现它们果真&ldquo;名不虚传&rdquo;。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897567/201611/897567-20161130164109646-2002172007.png" /></p>
<p>　　为了方便捋清楚这些概念和之间的相互关系，本人对其进行了系统的总结，欢迎讨论。</p>
<p><strong>1.虚基类</strong></p>
<p>(1)作用：间接派生类只保存共同基类的一份成员（数据成员/函数成员），优化存储空间。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897567/201611/897567-20161130165005443-987393140.png" /></p>
<p>(2)虚基类初始化方法：</p>
<p>　　在基类的直接派生类中声明为虚函数(virtual public B / virtual public C)，在最后的派生类中初始化直接基类和虚基类（这一点要特别注意，虚基类也是由最后的派生类执行，会屏蔽直接派生类对虚基类的初始化【避免虚基类多次初始化】，即D必须对A、B、C进行初始化，B和C对A的初始化不起作用。）</p>
<p>(3)栗子</p>
<div>
<pre class="prettyprint linenums"> #include &lt;iostream&gt;<br />
 using namespace std;

 //虚基类<br />
 class A<br />
 {<br />
 public:<br />
     A(int da)<br />
     {<br />
         data_a = da;<br />
         cout &lt;&lt; "A" &lt;&lt; endl;<br />
     }<br />
     ~A()<br />
     {<br />
         cout &lt;&lt; "~A" &lt;&lt; endl;<br />
     }<br />
 protected:<br />
     int data_a;<br />
 };<br />
 //直接派生类<br />
 class B :virtual public A<br />
 {<br />
 public:<br />
    B(int da, int db) :A(da)<br />
     {<br />
         data_b = db;<br />
         cout &lt;&lt; "B" &lt;&lt; endl;<br />
     }<br />
     ~B()<br />
     {<br />
         cout &lt;&lt; "~B" &lt;&lt; endl;<br />
     }<br />
 protected:<br />
     int data_b;<br />
 };

 //直接派生类<br />
 class C :virtual public A<br />
 {<br />
 public:<br />
     C(int da, int dc) :A(da)<br />
     {<br />
         data_c = dc;<br />
         cout &lt;&lt; "C" &lt;&lt; endl;<br />
     }<br />
     ~C()<br />
     {<br />
         cout &lt;&lt; "~C" &lt;&lt; endl;<br />
     }<br />
 protected:<br />
     int data_c;<br />
 };<br />
 //间接派生类<br />
 class D : public B, public C<br />
 {<br />
 public:<br />
     D(int da, int db, int dc, int dd) :A(da), B(da, db), C(da, dc)<br />
     {<br />
         data_d = dd;<br />
         cout &lt;&lt; "D" &lt;&lt; endl;<br />
     }<br />
     ~D()<br />
     {<br />
         cout &lt;&lt; "~D" &lt;&lt; endl;<br />
     }<br />
     void display()<br />
     {<br />
        cout &lt;&lt; "data_a=" &lt;&lt; data_a &lt;&lt; "\t" &lt;&lt; "data_b=" &lt;&lt; data_b &lt;&lt; "\t" &lt;&lt; "data_c=" &lt;&lt; data_c &lt;&lt; "\t" &lt;&lt; "data_d=" &lt;&lt; data_d &lt;&lt; endl;<br />
     }<br />
 protected:<br />
     int data_d;<br />
 };

 int main()<br />
 {<br />
     D test_d(, , , );<br />
     test_d.display();

     return ;<br />
 }</pre>
</div>
<p>输出：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897567/201611/897567-20161130165344006-923249325.png" /></p>
<p>2.虚函数</p>
<p>（1）思考：在基类和派生类中存在两个函数不仅名字相同，参数个数也相同，但是功能不同即函数体不同【不是函数重载！】，如何实现两个函数的调用？</p>
<p>一般思路是采取同名覆盖原则，即派生类中同名函数覆盖掉基类同名函数，如果想调用基类的同名函数，必须用类作用域符::来进行区分。这种做法在派生结构复杂时使用不太方便，能否采用一种调用形式，既可以调用派生类也可以调用基类同名函数？</p>
<p>这就是虚函数大展手脚的时候了，虚函数允许在派生类中重新定义与基类同名的函数，并且允许通过基类指针或引用来访问基类和派生类的同名函数。</p>
<p>（2）栗子</p>
<div>
<pre class="prettyprint linenums">//main.cpp<br />
#include &lt;iostream&gt;<br />
#include "virtual.h"<br />
using namespace std;<br />
int main()<br />
{<br />
    Shape *pShape = new Shape();//定义基类指针，指向基类对象所在内存空间<br />
    pShape-&gt;PrintArea();<br />
    Retangle ret(, );<br />
    pShape = &amp;ret;//将基类指针指向派生类类型对象内存<br />
    pShape-&gt;PrintArea();<br />
    Circle cir();<br />
    pShape = &amp;cir;//将基类指针指向派生类类型对象内存<br />
    pShape-&gt;PrintArea();

    return ;<br />
}

//virtual.h<br />
#ifndef virtual_h<br />
#define virtual_h<br />
class Shape<br />
{<br />
public:<br />
    virtual void PrintArea();<br />
    virtual double CalculateArea();<br />
protected:<br />
    double area;<br />
};

class Retangle: public Shape<br />
{<br />
public:<br />
    Retangle(double len, double wid);<br />
    virtual void PrintArea();<br />
    virtual double CalculateArea();<br />
private:<br />
    double length;<br />
    double width;<br />
};

class Circle : public Shape<br />
{<br />
public:<br />
    Circle(double r);<br />
    virtual void PrintArea();<br />
    virtual double CalculateArea();<br />
private:<br />
    double radius;<br />
};<br />
#endif

//virtual.cpp<br />
#include "virtual.h"<br />
#include &lt;iostream&gt;<br />
using namespace std;<br />
void Shape::PrintArea()<br />
{<br />
    cout &lt;&lt; "当前没有形状设置!" &lt;&lt; endl;<br />
}<br />
double Shape::CalculateArea()<br />
{<br />
    return area;<br />
}<br />
Retangle::Retangle(double len, double wid)<br />
{<br />
    length = len;<br />
    width = wid;<br />
}<br />
double Retangle::CalculateArea()<br />
{<br />
    area = length * width;<br />
    return Shape::CalculateArea();<br />
}<br />
void Retangle::PrintArea()<br />
{<br />
    CalculateArea();<br />
    cout &lt;&lt; "矩阵面积为：" &lt;&lt; area &lt;&lt; endl;<br />
}<br />
Circle::Circle(double r)<br />
{<br />
    this-&gt;radius = r;<br />
}<br />
double Circle::CalculateArea()<br />
{<br />
    area = 3.14*radius*radius;<br />
    return Shape::CalculateArea();<br />
}<br />
void Circle::PrintArea()<br />
{<br />
    CalculateArea();<br />
    cout &lt;&lt; "圆的面积为：" &lt;&lt; area &lt;&lt; endl;<br />
}</pre>
</div>
<p>输出：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897567/201611/897567-20161130165804115-1856620307.png" /></p>
<p>（3）关于使用虚函数的好处：</p>
<p>1） 基类里声明为虚函数函数体可以为空，它的作用就是为了能让这个函数在它的子类里面可以被同名使用，这样编译器就可以使用后期绑定来达到多态了；</p>
<p>2） 通常我们把很多函数加上virtual，是一个好的习惯，虽然牺牲了一些性能，但是增加了面向对象的多态性，因为你很难预料到基类里面的这个函数不在派生类里面不去修改它的实现。</p>
<p>3.纯虚函数</p>
<p>　　纯虚函数就很好理解了，有些函数虽然并不是基类所需要的，但是派生类可能会用到，所以会在基类中为派生类保留一个函数名，以便以后派生类定义使用。纯虚函数不具备函数功能，是不能被调用的。</p>
<p>以上述代码为例，可以将Shape类中的&nbsp;<strong>PrintArea()</strong>定义为纯虚函数， <strong>virtual void PrintArea() = 0;</strong></p>
<p>4.虚析构函数</p>
<p>　　在学习<em><a href="http://www.cnblogs.com/always-chang/p/6118423.html" rel="external nofollow noreferrer">派生类的析构函数</a></em>时，留了一个坑，就是析构函数的调用次序问题，在不使用虚函数的前提下，析构函数的调用次序是：先调用派生类构造函数清理新增的成员，再调用子对象析构函数（基类构造函数）清理子对象，最后再调用基类构造函数清理基类成员，过程正好与构造函数的调用过程相反。</p>
<p>在使用虚函数时，析构函数的调用会出现哪些情况？</p>
<p>同样是虚函数例子中的代码（加上构造和析构语句），进行以下测试：</p>
<div>
<pre class="prettyprint linenums"> int main()<br />
 {<br />
     Shape *pShape = new Circle();//基类指针指向派生类对象内存空间<br />
     delete pShape;<br />
     pShape = NULL;

     return ;<br />
 }</pre>
</div>
<p>输出：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897567/201611/897567-20161130170528271-970505338.png" /></p>
<p>测试结果表明：<strong>程序调用了两次构造函数，但是只调用了一次析构函数，造成了内存泄漏。</strong></p>
<p>这是因为派生类析构函数无法从基类继承，在没有声明基类析构函数为虚函数时，基类指针释放时无法找到派生类析构函数地址，也就不能释放派生类对象所在内存空间。而将基类析构函数也声明为虚函数时，该基类所有派生类也将自动成为虚函数，所有虚析构函数的入口地址都会存放在一个虚函数表（指针数组）中，查找方便，这样就避免了无法调用派生类析构函数所造成的内存泄漏问题了。</p>
<p>5.总结：</p>
<p>(1).虚析构函数是建立在虚函数的基础之上的，即在想使用基类指针访问派生类对象时必须要声明基类虚析构函数，不管基类是否需要析构函数；</p>
<p>(2).因为虚函数表会占据一定的空间开销，在不存在上述1中情况时没有必要使用虚函数；</p>
<p>(3).多态性：因为编译器只做静态的语法检查，无法确定调用对象，运行时才确定关联关系，所以多态性又分为静态多态性和动态多态性。</p>
<p>　　静态多态性（编译时的多态性，静态关联）是指在程序编译时就能够确定调用的是哪个函数，函数重载/运算符重载/通过对象名调用的虚函数都属于静态关联。</p>
<p>　　动态多态性（运行时多态性，动态关联，滞后关联）是指只有在程序运行时才能够确定操作的对象，通过虚函数实现。</p>
<p>6.参考：</p>
<p><a href="http://blog.chinaunix.net/uid-26851094-id-3327323.html" rel="external nofollow noreferrer"><em>http://blog.chinaunix.net/uid-26851094-id-3327323.html</em></a></p>
<p><em><a href="http://blog.sina.com.cn/s/blog_7c773cc50100y9hz.html" rel="external nofollow noreferrer">http://blog.sina.com.cn/s/blog_7c773cc50100y9hz.html</a></em></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnk1yxq.html">在IE6、IE7中实现块元素的inline-block效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o7n3pq.html">BlockingQueue详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mmljjq.html">php flush&lpar;&rpar;刷新不能输出缓冲的原因分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zvj359.html">linux下不重启添加硬盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmpw109.html">Entity Framework学习笔记&lpar;二&rpar;----CRUD&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdekmdx9.html">C&plus;&plus;输入输出流的重载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm202k9.html">【poj3693】Maximum repetition substring（后缀数组&plus;RMQ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x6pmz8.html">&lbrack;jQuery&rsqb;无法获取隐藏元素（display&colon;none）宽度&lpar;width&rpar;和高度&lpar;height&rpar;的新解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zxlxx9.html">mysql root密码重置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90my2748.html">Vijos 1011 清帝之惑之顺治 记忆录式的动态规划（记忆化搜索）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp2klr9.html">Python学习之数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pkyz38.html">Redis笔记4-持久化方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp3rlzq.html">织梦dedecms列表序号从0到1开始的办法 autoindex&comma;itemindex标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1o6rxq.html">react实战第一步--搭建项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/96px43j8.html">Java开发笔记（十六）非此即彼的条件分支</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgj5jd8.html">js 执行顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gje7249.html">人脸检测（1）&mdash;&mdash;HOG特征</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjng1r9.html">Spark的四种部署方式并对应四种提交方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll537eq.html">Java基础知识➣序列化与反序列化（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy6mkd9.html">mysql 拒绝登录解决</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qx2rjg08.html">Android多点触摸放大缩小图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2rj7d8.html">fork函数相关总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/953v1ne8.html">CListCtrl获取列数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4w03lq.html">解决windows server2012 评估版本过期，系统会自动关机</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnkokjq.html">Python学习笔记11：标准库之文件管理（os包，shutil包）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93plz0z8.html">Firefox清空缓存的快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vn1x0q.html">&lbrack;k8s&rsqb;容器化node-expolore&lpar;9100&rpar;&plus;cadvisor&lpar;8080&rpar;&plus;prometheus&lpar;9090&rpar; metric搜集&comma;grafana展示</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4wzppq.html">C&plus;&plus;学习笔记16，C&plus;&plus;11中的显式的默认构造函数以及显示删除默认构造函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvlm7gq.html">mongoose中的versionKey</a>
			</li>
						<li><a href="https://www.batexi.com/a/963k14n9.html">Ubuntu 安装谷歌拼音输入法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
